﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ThinkGeo.MapSuite.MvcEdition;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;
using System.Drawing;

namespace DisplayASimpleMapForMvc.Controllers
{
    public class IndexController : Controller
    {
        //
        // GET: /UseDraggableMarkers/

        public ActionResult Index()
        {
            Map map = new Map("Map1",
                    new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage),
                    500);
            map.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            map.CurrentExtent = new RectangleShape(-10845454.046933, 3871686.1662579, -10844454.046933, 3870686.1662579);
            map.MapUnit = GeographyUnit.Meter;

            LayerOverlay googleOverlay = new LayerOverlay();
            googleOverlay.TileType = TileType.SingleTile;
            googleOverlay.IsBaseOverlay = true;

            GoogleMapsLayer googleLayer = new GoogleMapsLayer();
            //googleLayer.ClientId = "";
            //googleLayer.PrivateKey = "";
            googleLayer.CreatingRequest += googleLayer_CreatingRequest;
            googleLayer.TileMode = GoogleMapsTileMode.SingleTile;
            googleLayer.MapType = GoogleMapsMapType.Hybrid;
            googleOverlay.Layers.Add(googleLayer);

            map.CustomOverlays.Add(googleOverlay);
            return View(map);
        }

        void googleLayer_CreatingRequest(object sender, CreatingRequestGoogleMapsLayerEventArgs e)
        {
            e.RequestUri = new Uri(e.RequestUri.AbsoluteUri + "&key=AIzaSyB3XuvpGz4dooLr7mcP3GXC7he4o0RGAj0");
            //throw new NotImplementedException();
        }

        [MapActionFilter]
        public void ExportBitmap(Map map, GeoCollection<object> args)
        {
            int width = Int32.Parse(args[0].ToString());
            int height = Int32.Parse(args[1].ToString());

            Bitmap result = map.GetBitmap(width, height);
            result.Save(string.Format("d:\\{0}.png",Guid.NewGuid().ToString()));
        }
    }
}
